	
Set_resolution
	MOVE.B 		#33,D0
	MOVE.L 		#765*$10000+535,D1		; Set screen to 800 x 800
     	TRAP   		#15
     	RTS
set_solid						; set the background into gray for once !!!!
	MOVE.L		#$007F7F7F,D1
	set_color
	set_fillcolor
	MOVEQ		#0,D1
	MOVEQ		#0,D2
	MOVE.L		#765,D3
	MOVE.L		#535,D4
	draw_rect					
							; the whole screen
**************
	MOVE.L		#$00FF0000,D1
	set_color
	set_fillcolor
	MOVE.L		#564,D1
	MOVE.L		#17,D2
	MOVE.L		#724,D3
	MOVE.L		#227,D4
	draw_rect
**************							
	RTS 
Draw_background
	MOVEM.L		D0-D7,-(SP)

	
	MOVE.L		#$00267FFF,D1			; Set color orange
	set_color
	set_fillcolor
	
	MOVEQ		#0,D1
	MOVEQ		#0,D2
	MOVE.L		#535,D3
	MOVE.L		#532,D4
	draw_rect
							; draw a big filled orange rectangle
	MOVE.L		#0,D1
	set_fillcolor
	MOVEQ		#5,D1
	MOVEQ		#3,D2
	MOVE.L		#530,D3
	MOVE.L		#528,D4
	draw_rect
							; draw a black rectangle in the heart of the orange one !
	MOVE.L		#$00FF0000,D1
	set_color
	set_fillcolor
	
	MOVE.L		#30,D5
loop1
	MOVE.L		#28,D6
loop2	
	MOVE.L		D5,D1
	MOVE.L		D6,D2
	MOVE.L		D5,D3
	MOVE.L		D6,D4
	ADDI.L		#25,D3
	ADDI.L		#25,D4
	
	draw_rect
							; the little blue ones !! smurfs(:-")
	
	ADDI		#50,D6
	CMPI.L		#525,D6
	BMI		loop2
DONE2
	ADDI		#50,D5
	CMPI.L		#525,D5	
	BMI		loop1
DONE1	
	MOVEM.L		(SP)+,D0-D7
	RTS

    	
Draw_picture
	BSR		Graphic_init			* go setup stuff
	BSR		open_file			* go open a file
	BSR		load_file			* load the file
	BSR		bm_image_header			* get the image header information
	BSR		display_image			* was all ok so show the image
	RTS
**
************************************************************************************
*
* recomanded setups based on the simulator help. only im_x and im_y are directly related to the image
; the origin is set with D1 D2	
Graphic_init
	MOVE.L		A1,A4
	MOVE.w		D1,im_x				* set the image x origin
	MOVE.w		D2,im_y				* set the image y origin

	MOVEQ		#0,D1				* turn off keyboard echo
	MOVEQ		#12,D0				* keyboard echo
	TRAP		#15

	MOVE.w		#$FF00,D1			* clear screen
	MOVEQ		#11,D0				* position cursor
	TRAP		#15

	MOVEQ		#50,D0				* close all files
	TRAP		#15
	
	
	RTS


*************************************************************************************
*

open_file
	
	MOVE		#51,d0			
	TRAP		#15				* open the file
	MOVE.L		D1,file_id			* save the file ID
	RTS



*************************************************************************************
*
* load the file. this first loads the header and checks for the "BM" signature. if
* the load succeedes and the signature is correct it loads the body of the file and
* checks that it too has loaded from the expected byte count
*

* the bitmap file header is made up as follows
*
*	dc.b	'BM'					* *.bmp file header signature bytes

*	dc.l	size					* the total i0ze of the file
*	dc.w	reserved				* usually zero
*	dc.w	reserved				* usually zero
*	dc.l	offset					* the offset to the start of the image data
*							* from the start of the file

load_file
	MOVE.l		file_id,D1			* get the file ID

	MOVE.L		A4,A1			* point to the file buffer
	MOVEQ		#$0E,D2				* set the byte count to load the file header , 14 byte must be read for the header
	MOVE.l		D2,D3				* copy the file header byte count
	MOVEQ		#53,D0				* read from the file
	TRAP		#15

	CMP.l		D3,D2				* compare the bytes read with the expected
							* byte count

	BNE.s		exit_load_file			* if incorrect do failure exit

	CMPI.w		#'BM',(A1)+			* compare the signature word with "BM"
	BNE.s		exit_load_file			* if incorrect do failure exit

	NEG.l		D2				* negate the byte count so far,	d2 byte has been read
	BSR		get_long				* get the file size	
	ADD.l		D0,D2				* add the file size longword to give the
							* remaining byte count in D2
	MOVE.l		D2,D3				* copy the remaining byte count
	ADDQ.w		#4,A1				* skip the two reserved words
	BSR		get_long				* get the image start offset
	SUB.l		#$0E,D0				* subtract the file header size
	LEA		im_file,A2
	MOVE.l		D0,image_start			* save the image start offset the image starts from d0 that we save it in image_start

	MOVE.L		A4,A1				* point to the file buffer
	MOVEQ		#53,D0				* read from the file
	TRAP		#15

	CMP.l		D3,D2				* compare the bytes read with the expected
							* byte count
	BNE.s		exit_load_file			* if incorrect do failure exit

	MOVEQ		#0,D1				* flag load succeeded
	RTS

exit_load_file
	MOVEQ		#-1,D1				* flag load failed
							* must not reach here !!!!!
	RTS


*************************************************************************************
*
* check the *.bmp image header and get the image information, if needed load the
* palette

* the bitmap image header is made up as follows
*
*	dc.l	header_size				* should be 40
*	dc.l	im_width				* image width in pixels
*	dc.l	im_height				* image height in pixels
*	dc.w	bitplanes				* number of planes, should be 1
*	dc.w	im_depth				* number of bits per pixel, should be one
*							* of 1, 4 8 or 24
*	dc.l	compression				* type of compression, should be zero, no
*							* compression
*	dc.l	im_size					* size of the image data in bytes. if there
*							* is no compression this can be set to zero
*	dc.l	im_x_ppm				* x resolution in pixels per meter, usually zero
*	dc.l	im_y_ppm				* y resolution in pixels per meter, usually zero
*	dc.l	colours_used				* number of colours used, usually zero
*	dc.l	colours_important			* number of important colours, usually zero

bm_image_header
	MOVEQ		#-1,D1				* flag failed

	MOVEQ		#$28,D2				* set the size that is expected
	BSR		get_long			* get the image header size
	CMP.l		D2,D0				* compare them
	BNE.s		exit_bm_image_header		* if incorrect just exit

	BSR		get_long			* get the image width
	MOVE.l		D0,im_width			* save the image width
	BSR		get_long			* get the image height
	MOVE.l		D0,im_height		* save the image height

	BSR		get_word			* get the number of planes
	CMPI.w		#1,D0				* compare with expected number
	BNE.s		exit_bm_image_header		* if incorrect just exit

	BSR		get_word			* get the image depth

	BSR		get_long			* get the compression type ,must be zero
	MOVE.l		D0,D1				* flag success only if d0 is zero
	BNE.s		exit_bm_image_header		* if incorrect just exit

	LEA		$14(A1),A1			* skip the rest of the header

exit_bm_image_header
	**must not fail in here
	RTS



*************************************************************************************
*
* display the image. from point(10,10) to (where ever it takes)

display_image
	MOVEQ		#0,D1				* get the window size, put 0 and get the size or put 1 and set the size
	MOVEQ 		#33,D0				* get/set the window size
	TRAP		#15

do_image
	LEA		im_file,A1			* point to the file buffer
	ADDA.l		image_start,A1			* add the image start offset

	BRA		display_real			* if 24bbp go do real colour display

	RTS

*************************************************************************************
*
* load a twenty four bit, real colour, bitmap. image line data is padded to the next
* even word so unused bytes have to be skipped

*	d4 is the sum
*	d5 is the x
*	d6 is the y 
display_real
				* mask byte remainder
	
	MOVE.L		im_width,D4
	ADD.L		im_height,D4
real_sum_loop
	MOVE.l		im_width,D5			* get the image width
real_x_loop
	MOVE.L		D4,D6
	SUB.L		D5,D6				* D5 is now the y
	BMI		not_good
	CMP.L		im_height,D6			* if D6 is bigger than height
	BPL		never_good
	MOVE.L		im_width,D7
	
	* when we need pixel (i,j) we should use formula i*width+j but every line that is loaded has a -2 displacement !!!
	* the three time add is because the R G B of every pixel and because we dont have a long MUL
	MULU.W		D6,D7				
	
	MOVE.L		D7,D3
	ADD.L		D3,D7
	ADD.L		D3,D7
	
	MOVE.L		im_height,D3
	SUB.L		D6,D3
	MULS		#-2,D3
	ADD.L		D3,D7
	
	ADD.L		D5,D7
	ADD.L		D5,D7
	ADD.L		D5,D7
	
	SUB.L		#1230,D7			* a constant that must be !

	MOVE.L		#0,D1				* clear the longword
	ADD.L		A1,D7
	MOVEA.L		D7,A5
	MOVE.b		(A5)+,D1			* get the blue byte
	SWAP		D1				* move it to the high word
	MOVE.b		(A5)+,D1			* get the green byte
	ROL.w		#8,D1				* move it to the high byte
	MOVE.b		(A5)+,D1			* get the red byte

	BSR		set_colour			* set the pen colour and draw the pixel
not_good
	DBF		D5,real_x_loop			* loop for the next pixel
never_good
	DBF		D4,real_sum_loop		* loop for next line

	RTS



*------------------------------------------------------------------------------------
*
* set the pen colour from d1.l and draw the pixel

set_colour
	MOVEQ		#80,D0				 * set the pen colour
	TRAP		#15
	
	CLR		D1
	CLR		D2
	MOVE.w		im_x,D1				* copy the x co-ordinate
	MOVE.w		im_y,D2				* copy the y co-ordinate
	ADD.L 		D5,D1				* adjust the x pixel
	SUB.L		D6,D2				* adjust the y pixel - afghani save kardane BMP
	ADD.L		im_height,D2			* adjust the y pixel
	
	MOVEQ		#82,D0				* draw a pixel
	TRAP		#15


	RTS


***********************************************************************w**************
*
* get a little endian word. returns the result in d0.w and increments the pointer

get_word
	MOVE.b		(A1)+,D0			* get the low byte
	ROL.w		#8,D0				* move it
	MOVE.b		(A1)+,D0			* get the high byte
	ROL.w		#8,D0				* swap the bytes
	RTS


*************************************************************************************
*
* get a little endian longword. returns the result in d0.l and increments the pointer

get_long
	BSR.s		get_word			* get a little endian word
	SWAP		D0				* move it
	BSR.s		get_word			* get a little endian word
	SWAP		D0				* swap the words
	RTS





*************************************************************************************	
*** writes the string loaded in A1
Draw_the_interrupt
	MOVEM		D0-D7,-(SP)			* save them 
	MOVE.L		#$00577AB9,D1			* set color
	set_color
	set_fillcolor
	MOVE.L		#120,D1				* set coordinate x1
	MOVE.L		#120,D2				* set y1
	MOVE.L		#410,D3				* set x2
	MOVE.L		#410,D4				* set y2
	draw_rect					
							* draw the brown square
	MOVE.L 		#190,D1				
	MOVE.L 		#265,D2
	MOVE.B 		#95,D0
	TRAP		#15
	show

	MOVEM		(SP)+,D0-D7
	RTS






















*~Font name~Courier New~
*~Font size~10~
*~Tab type~1~
*~Tab size~8~
